 /*	
	dataspy network x version 0.5 beta
	Copyright (C) 2002 dataspy dot net INC

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
  */



#ifndef _SHARED_HEADER_
#define _SHARED_HEADER_

#define DSNXSocket_ID			2
#define MainBot_ID				7
#define PortRedirect_ID			8

/*
 * DSNX_Command - the default command that the users call
 *
 * char *buffer - the buffer where the reply to the user is to be printed (if the first char is null then no reply will be sent)
 * DSNXSocket *bot   - the
 * char *where -
 * char *from -
 * int parv -
 * char **parc -
 * ushort auth_lvl -

 */

#ifdef DSNX_PLUGIN

#define MainBot void

#else

#include "../include/mainbot.h"

#endif

typedef bool (*DSNX_Command)(char*				buffer,
							 char*				from,
							 char*				mask,
							 char*				where, 	
							 MainBot*			bot, 
							 unsigned short		parv,
							 char				**parc,
							 unsigned short		auth_lvl
							 );

#define DSNX_CMD_PARAMS (	char*buffer,			/* reply Buffer */\
							char* from,				/* NICK from user originating command */\
							char* mask,				/* MASK from user originating command */\
							char* where,			/* Chan */\
							MainBot* bot,			/*  */\
							unsigned short argc,	/* arg count */\
							char **args,			/* pointer to arguments */\
							unsigned short auth_lvl /* authorisation level */\
							)


typedef bool				(*pAddPluginCmd)		(char *cid,DSNX_Command command,USHORT auth_lvl,char *plugin_name);
typedef bool				(*pIsValidSock)			(void *pointer);
typedef void				(*pSendMsgFromMainbot)	(void *bot,char *message,char *to,char *where,bool Error);

typedef SOCKET				(*pTCPConnect)			(const char *Address,USHORT iPort);
typedef int					(*pTCPSend)				(UINT The_Socket,const char* buf,int count);
typedef int					(*pTCPRecv)				(SOCKET The_Socket, char **pInData);
typedef SOCKET				(*pTCPListen)			(int nPort);
typedef SOCKET				(*pTCPAccept)			(SOCKET The_Socket);
typedef unsigned int		(*pRandom)				(int iLow, int iHigh);
typedef char*				(*pRandomText)			(char*cBuffer,int iLength);
typedef	SOCKET				(*pSmartConnect)		(char* cServer,UINT iPort,USHORT max_seconds);

struct DSNXExports {

	pAddPluginCmd		AddPluginCmd;
	pIsValidSock		IsValidSock;
	pTCPConnect			TCPConnect;
	pTCPSend			TCPSend;
	pTCPRecv			TCPRecv;

	pTCPListen			TCPListen;
	pTCPAccept			TCPAccept;
	pRandom				Random;
	pRandomText			RandomText;
	pSmartConnect		SmartConnect;

	pSendMsgFromMainbot	SendMsgFromMainbot;
};


typedef void (*pPluginAction)(void);

struct DSNXPluginReturn {

	char plugin_name[256];
	pPluginAction Unload;
	pPluginAction Load;
};

typedef BOOL (*PluginStartup)(DSNXExports*,DSNXPluginReturn *);



#endif //_SHARED_HEADER_