 /*	
	dataspy network x version 0.5 beta
	Copyright (C) 2002 dataspy dot net INC

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
  */

 /*

	CLinkedLists.cpp - Base class for all other clases, enables us to keep track of em.

	Last revised : 31st March 2002

  */


#include <windows.h>
#include <string.h>

#include "../include/CLinkedLists.h"

CLinkedList::CLinkedList (char *to_be_named,void *p) {

	if ( to_be_named != 0 ) {

		name = new char[strlen(to_be_named) + 1];

		strcpy(name,to_be_named);

	} 
	else
		name = 0;

	pointer = p;

	pLast = pNext = this;
	
}

CLinkedList::~CLinkedList() {

	if (name != 0)
		delete name;
}

bool CLinkedList::Insert (CLinkedList **InsertMeInto,short Position ) {

	if (!*InsertMeInto || *InsertMeInto == this) {
		*InsertMeInto = this;
		return true;
	}

	CLinkedList *InsertPosition = (*InsertMeInto)->Get(Position);

	if (name != 0) {
		if ( /* (*InsertMeInto)->Get(name) != 0 || */ !*name)
			return true;
	}

	InsertPosition->pNext->pLast = this;
	pNext = InsertPosition->pNext; 
	InsertPosition->pNext = this;		
	pLast = InsertPosition;		

	return true;
}

bool CLinkedList::Remove (CLinkedList **RemoveMeFrom) {

	if (!*RemoveMeFrom) {
		return false;
	}

	/* We the only list in the list ? */
	if ((*RemoveMeFrom)->pNext == (*RemoveMeFrom) && (*RemoveMeFrom) == this) {
		*RemoveMeFrom =0;
		return true;
	}

	pNext->pLast = pLast;
	pLast->pNext = pNext;

	if (*RemoveMeFrom != this) {
		return true;
	}
	else {
		*RemoveMeFrom = pNext;
		return true;
	}
}

CLinkedList *CLinkedList::Get (short Offset) {

	CLinkedList *list = this;

	while (Offset > 0) {
		
		Offset--;
		list = list->pNext;
	}

	while (Offset < 0) {
		Offset++;
		list = list->pLast;
	}

	return list;
}

CLinkedList *CLinkedList::Get(char *match) {

	CLinkedList *list =this;

	do {

		if (list->name) {
			if (!stricmp(list->name,match)) {
				return list;
			}
		}

		list = list->Get(1);
	
	} while (list != this);

	return 0;	
}

unsigned short CLinkedList::Count(void) {

	CLinkedList *list = this;
	unsigned short count =0;

	do {

		count++;
		list = list->Get(1);

	} while (list !=this);

	return count;
}

bool CLinkedList::Rename(char *new_name) {

	if (Get(new_name))
		return false;

	if (name != 0)
		delete name;

	name = new char[strlen(new_name) + 1];
	strcpy(name,new_name);

	return true;



}