 /*	
	dataspy network x version 0.5 beta
	Copyright (C) 2002 dataspy dot net INC

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
  */

 /*

	auth.cpp - Authenticates users with passwords (md5) matched to auth levels

	Last revised : 31st March 2002

  */


#include <stdio.h>
#include "../include/auth.h"
#include "../include/settingstorage.h"
#include "../include/md5.h"

char **g_cHostAllows;				 //For hostmask authentication
unsigned short g_iHostAllows=0;

/*

  Testing name agains mask

  */

int CmpMask(char *mask, char *name)
{
	unsigned char *m;		/* why didn't the old one use registers ?!??!?!?! */
	unsigned char *n;
	unsigned char cm;
	unsigned char *wsn;
	unsigned char *wsm;

	m = (unsigned char *)mask;

	cm = *m;

#define lc(x) tolower(x)

	n = (unsigned char *)name;
	if (cm == '*')
	{
		if (m[1] == '\0')	/* mask is just "*", so true */
			return 0;
	}
	else if (cm != '?' && lc(cm) != lc(*n))
		return 1;	/* most likely first chars won't match */
	else
	{
		m++;
		n++;
	}
	cm = lc(*m);
	wsm = (unsigned char *)NULL;
	while (1)
	{
		if (cm == '*')	/* found the * wildcard */
		{
			m++;	/* go to next char of mask */
			if (!*m)	/* if at end of mask, */
				return 0;	/* function becomes true. */
			while (*m == '*')	/* while the char at m is "*" */
			{
				m++;	/* go to next char of mask */
				if (!*m)	/* if at end of mask, */
					return 0;	/* function becomes true. */
			}
			cm = *m;
			if (cm == '\\')	/* don't do ? checking if a \ */
			{
				cm = *(++m);	/* just skip this char, no ? checking */
			}
			else if (cm == '?')	/* if it's a ? */
			{
				do
				{
					m++;	/* go to the next char of both */
					n++;
					if (!*n)	/* if end of test string... */
						return (!*m ? 0 : 1);	/* true if end of mask str, else false */
				}
				while (*m == '?');	/* while we have ?'s */
				cm = *m;
				if (!cm)	/* last char of mask is ?, so it's true */
					return 0;
			}
			cm = lc(cm);
			while (lc(*n) != cm)
			{	/* compare */
				n++;	/* go to next char of n */
				if (!*n)	/* if at end of n string */
					return 1;	/* function becomes false. */
			}
			wsm = m;	/* mark after where wildcard found */
			cm = lc(*(++m));	/* go to next mask char */
			wsn = n;	/* mark spot first char was found */
			n++;	/* go to next char of n */
			continue;
		}
		if (cm == '?')	/* found ? wildcard */
		{
			cm = lc(*(++m));	/* just skip and go to next */
			n++;
			if (!*n)	/* return true if end of both, */
				return (cm ? 1 : 0);	/* false if end of test str only */
			continue;
		}
		if (cm == '\\')	/* next char will not be a wildcard. */
		{		/* skip wild checking, don't continue */
			cm = lc(*(++m));
			n++;
		}
		/* Complicated to read, but to save CPU time.  Every ounce counts. */
		if (lc(*n) != cm)	/* if the current chars don't equal, */
		{
			if (!wsm)	/* if there was no * wildcard, */
				return 1;	/* function becomes false. */
			n = wsn + 1;	/* start on char after the one we found last */
			m = wsm;	/* set m to the spot after the "*" */
			cm = lc(*m);
			while (cm != lc(*n))
			{	/* compare them */
				n++;	/* go to next char of n */
				if (!*n)	/* if we reached end of n string, */
					return 1;	/* function becomes false. */
			}
			 wsn = n;	/* mark spot first char was found */
		}
		if (!cm)	/* cm == cn, so if !cm, then we've */
			return 0;	/* reached end of BOTH, so it matches */
		m++;		/* go to next mask char */
		n++;		/* go to next testing char */
		cm = lc(*m);	/* pointers are slower */
	}
	return 1;
}


/*
	In order to get a return TRUE; from this function the user must:
		=Match at least one hostmask as specified in the HOSTMASK option
		=Give the correct password which when hashed using MD5 matches the hash set in the HASH_LEVEL1 option
		=Not already be logged in
		=If there is already one login, the option MULTIPLE_LOGONS is TRUE

  */

IRCAuth::IRCAuth(char *cNick,char*cMask,unsigned short uLevel) : CLinkedList(cNick) {

	mask = new char [strlen(cMask) + 1];

	if (mask) {
		strcpy(mask,cMask);
	}

	level = uLevel;
	

}

IRCAuth::~IRCAuth () {

	if (mask != 0)
		delete mask;
}


BOOL IRCLogin(char* password,char* nick,char *mask,CLinkedList **auth) {

	char hostmask[256];
	short hTrys=g_iHostAllows,auth_lvl =MAX_AUTH_LVL;
	MD5_CTX context;
	unsigned char digest[16];
	unsigned char mdigest[33];
	char *p,glvl[16],
		*mlgn = GetSetting("mlgn");

	if (mlgn) {

		if (*auth != 0)
		if (atoi (mlgn) <= (*auth)->Count())
			return FALSE;
	}

	sprintf(hostmask,"%s!%s",nick,mask);

	while (hTrys-- > 0) {
		if(!CmpMask(g_cHostAllows[hTrys],hostmask))
			break;
	}

	if (hTrys == -1)
		return FALSE;

	MD5Init (&context);
	MD5Update (&context, (unsigned char*)password, strlen(password));
	MD5Final (digest, &context);
	MDPrint(digest,mdigest);

	while (auth_lvl > 0) {

		sprintf(glvl,"PASS_%d",auth_lvl--);
		p = GetSetting(glvl);

		if (!p)
			continue;

		if (!stricmp((const char*)mdigest,p) ) {//&& strlen(p) == strlen(p)) {
			auth_lvl ++;
			break;
		}

	}

	if (auth_lvl > 0) {

		IRCAuth *NewAuth = new IRCAuth(nick,mask,auth_lvl);
		
		//*auth = (CLinkedList*)
			NewAuth->Insert(auth);
	
		return TRUE;
	}

	return FALSE;

}

BOOL IRCLogout(char *nick,CLinkedList ** auth) {

	if (*auth == 0) 
		return FALSE;

	CLinkedList *toremove = (*auth)->Get(nick);

	if (toremove == 0)
		return FALSE;

	toremove-> Remove(auth);

	delete toremove;

	return TRUE;

}

/*

  Returns level of validation,
			or
	0 for not logged in
			or
	-1 for nick the same, but mask changed

  */

short Validate(char *nick,char*mask,CLinkedList *auth) {
 
	if (auth == 0)
		return NO_AUTH;

	CLinkedList *list = auth->Get (nick);

	if (list == 0)
		return NO_AUTH;

	if (!stricmp(((IRCAuth*)list)->mask,mask)) //,strlen(m)) && strlen(m) == strlen(mask))
		return ((IRCAuth*)list)->level;
	else
		return HOST_CHANGED_AUTH_LVL;

}



