 /*	
	dataspy network x version 0.5 beta
	Copyright (C) 2002 dataspy dot net INC

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
  */

 /*

	Tcp.cpp - Tcp stuff

	Last revised : 31st March 2002

  */



#include <winsock.h>
//#include <ras.h>
#include "..\include\tcp.h"

BOOL StartWinsock(void)
{
	WSADATA WSock_dat;
	WORD WSock_ver=MAKEWORD(2,0);


	if(WSAStartup(WSock_ver,&WSock_dat)) {
		return FALSE;
	}

	return TRUE;
}

SOCKET TCPConnect(const char *Address,USHORT iPort)
{
	int res;
	SOCKET The_Socket = INVALID_SOCKET;
	IN_ADDR	iaHost;
	LPHOSTENT lpHostEntry;
	SOCKADDR_IN Destination;

	Destination.sin_family=AF_INET;
	Destination.sin_port = htons(iPort);
	
	iaHost.s_addr = inet_addr(Address);

	if (iaHost.s_addr == INADDR_NONE)
		lpHostEntry = gethostbyname(Address);
	else
		lpHostEntry = gethostbyaddr((const char *)&iaHost, sizeof(struct in_addr), AF_INET);

	if (lpHostEntry == NULL) {
			return INVALID_SOCKET;
	}

	The_Socket=socket(AF_INET,SOCK_STREAM,IPPROTO_TCP);

	if(The_Socket == INVALID_SOCKET) {
			return INVALID_SOCKET;
	}

	Destination.sin_addr = *((LPIN_ADDR)*lpHostEntry->h_addr_list);

	res = connect(The_Socket,(LPSOCKADDR)&Destination,sizeof(SOCKADDR_IN));

	if(res!=0) {
			return INVALID_SOCKET;
	}

	return The_Socket;

}

int TCPSend(UINT The_Socket,const char* buf,int count)
{
	// Send packet
	int ret;
	TIMEVAL tm;
	fd_set wfds;
	FD_ZERO(&wfds);
	FD_SET(The_Socket,&wfds);
	tm.tv_sec=5;
	tm.tv_usec=0;
	if((ret=select(0,NULL,&wfds,NULL,&tm))>0) {
		do {
			ret=send(The_Socket,buf,count,0);
			if(ret==SOCKET_ERROR) break;

			count-=ret;
			buf+=ret;
			if(count>0) Sleep(20);
		} while(count>0);
		if(ret==SOCKET_ERROR)
			return -1;
		return 1;
	}
	return ret;
}

int TCPRecv (SOCKET The_Socket, char **pInData)
{
	TIMEVAL tv;
	fd_set rfds;
	DWORD len;
	char *pbuf,*buf;
	int count,lenret=0,nRet;

	tv.tv_sec=0;
	tv.tv_usec=0;
	FD_ZERO(&rfds);
	FD_SET(The_Socket,&rfds);
	nRet=select(1,&rfds,NULL,NULL,&tv);
	if(nRet==SOCKET_ERROR)
		return -1;
	if(nRet==0)
		return 0;

	if(ioctlsocket(The_Socket,FIONREAD,&len)==SOCKET_ERROR)
		return -1;

	if (!len)
		return -1;

	buf=new char[len+1];
	if(buf==NULL) {
		*pInData=NULL;
		return 0;
	}

	count = len;
	// Receive data
	pbuf=(char *)buf;
	do {
		lenret=recv(The_Socket,pbuf,count,0);
		if(lenret==SOCKET_ERROR)
		{
			free(buf);
			*pInData=NULL;
			return -1;
		}
		count-=lenret;
		pbuf+=lenret;
		if(count>0) 
			Sleep(20);
	} while(count>0);

	// Pass data back to application
	*pInData=buf;

	return len;
}

SOCKET TCPListen(int nPort)
{
	SOCKET The_Socket = INVALID_SOCKET;
	SOCKADDR_IN saddr;

	// Create listener socket
	The_Socket=socket(AF_INET,SOCK_STREAM,0);
	if(The_Socket==SOCKET_ERROR) {
		return INVALID_SOCKET;
	}

	// Bind socket and listen
	memset(&saddr,0,sizeof(SOCKADDR_IN));
	saddr.sin_addr.S_un .S_addr =INADDR_ANY;// =bindAddr;
	saddr.sin_family=AF_INET;
	saddr.sin_port=htons((WORD)nPort);

	if(bind(The_Socket,(SOCKADDR *) &saddr,sizeof(SOCKADDR_IN))==SOCKET_ERROR) {
		closesocket(The_Socket);
		return INVALID_SOCKET;
	}

	if(listen(The_Socket,SOMAXCONN)!=0) {
		closesocket(The_Socket);
		return INVALID_SOCKET;
	}

	return The_Socket;
}

SOCKET TCPAccept(SOCKET The_Socket)
{
	int len;
	// Check for connection
	fd_set rdfds;
	TIMEVAL tm;
	SOCKADDR_IN saddr;
	SOCKET accs;
		BOOL sopt;

	FD_ZERO(&rdfds);
	FD_SET(The_Socket,&rdfds);

	tm.tv_sec=0;
	tm.tv_usec=0;

	if(select(0,&rdfds,NULL,NULL,&tm)<=0) {
		return INVALID_SOCKET;
	}

	// Accept socket
	len=sizeof(SOCKADDR_IN);

	accs=accept(The_Socket,(SOCKADDR *)&saddr,&len);

	if(accs==INVALID_SOCKET){
		return INVALID_SOCKET;
	}

	sopt=TRUE;
	setsockopt(accs,IPPROTO_TCP,TCP_NODELAY,(char *)&sopt,sizeof(BOOL));
	sopt=TRUE;
	setsockopt(accs,SOL_SOCKET,SO_DONTLINGER,(char *)&sopt,sizeof(BOOL));

	return accs;
}
/*
char *EasySRecv(unsigned int The_Socket) //Just make it easier to get a string
{
	char *pdata = new char[MAX_BUFFER_LEN];
	int ret= SocketRecv(The_Socket,pdata);
	if (ret > 0) {
		pdata[ret] = '\0';
OutputDebugString(pdata);
	return pdata;
	} else {

		return "Error";
	}
}

typedef struct _RASCONNSTATUS {
    DWORD         dwSize;
    RASCONNSTATE  rasconnstate;
    DWORD         dwError;
    TCHAR         szDeviceType[RAS_MaxDeviceType + 1];
    TCHAR         szDeviceName[RAS_MaxDeviceName + 1];
} RASCONNSTATUS;
This function gets the connection info for us, and tells us wether we are connected to the net
*
BOOL IsConnected(void)
{
	LPRASCONN lpRasConn = NULL;
	DWORD   cbBuf = 0;
	DWORD   cConn = 0;
    DWORD   dwRet = 0;
    HRASCONN   hrasconn;
    RASCONNSTATUS rasStatus;
    UINT    ndx;

    // enumerate connections
    cbBuf = sizeof(RASCONN);
    if ( (lpRasConn = ( LPRASCONN ) malloc((UINT)cbBuf)) != NULL)
    {
		lpRasConn->dwSize = sizeof( RASCONN );
        dwRet = RasEnumConnections( lpRasConn, &cbBuf, &cConn );
		for (ndx = 0; ndx < cConn; ndx++)
		{
			// get to HRASCONN
			hrasconn = lpRasConn[ndx].hrasconn;

            rasStatus.dwSize = sizeof(RASCONNSTATUS);
			dwRet = RasGetConnectStatus( hrasconn, &rasStatus );
			if ( dwRet )
				return FALSE;
			else
			{
				if (rasStatus.rasconnstate == RASCS_Connected)
				{
					return TRUE;
				}
				else
					return FALSE;
			}
		}
		if (cConn == 0) { //No RAS, must be a lan? /me shrugs - try and connect anyway
			return TRUE;
		}
	}
   return FALSE;
}

*/
void HardClose(SOCKET s)
{
	LINGER s_linger;
	
	s_linger.l_onoff =1;
	s_linger.l_linger =0;

	setsockopt(s,SOL_SOCKET,SO_LINGER,(char*)&s_linger,sizeof(s_linger));

	closesocket(s);

	return;
}
