 /*	
	dataspy network x version 0.5 beta
	Copyright (C) 2002 dataspy dot net INC

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
  */

 /*

	tea.cpp - Our 128bit encryption! KTHX tea

	Last revised : 31st March 2002

  */


#include "../include/tea.h"

void TEADecrypt(const unsigned long *const v,unsigned long *const w,const unsigned long * const k)
{
  register unsigned long       y=v[0],z=v[1],
				//delta=0x9E3779B9,n=64,sum=0xC6EF3720;
				delta=0x9E3779B9,n=128,sum=delta *n;

   //* sum = delta<<5, in general sum = delta * n

   while(n-->0)
      {
      z -= (y << 4 ^ y >> 5) + y ^ sum + k[sum>>11 & 3];
      sum -= delta;
      y -= (z << 4 ^ z >> 5) + z ^ sum + k[sum&3];
      }

   w[0]=y; w[1]=z;
}
void Decrypt(char *buffer,pENCRYPTION_KEY key,unsigned long len)
{
	BYTE in[8],out[8];	
	int iReadLen=0;

	while (len >= 8)
	{
		len -=8;
		memcpy(in,buffer + iReadLen,8);
		TEADecrypt((unsigned long*)in,(unsigned long*)out,key);
		memcpy(buffer + iReadLen,out,8);
		iReadLen+=8;
	}
}

void TEAEncrypt (const unsigned long *const v,unsigned long *const w,const unsigned long * const k)
{
   register unsigned long       y=v[0],z=v[1],sum=0,delta=0x9E3779B9,n=128;

   while(n-->0)
      {
      y += (z << 4 ^ z >> 5) + z ^ sum + k[sum&3];
      sum += delta;
      z += (y << 4 ^ y >> 5) + y ^ sum + k[sum>>11 & 3];
      }

   w[0]=y; w[1]=z; 
}

void Encrypt(char *buffer,pENCRYPTION_KEY key,unsigned long len)
{
	unsigned char in[8],out[8];	
	int iReadLen=0;

	while (len >= 8)
	{
		len -= 8;
		memcpy(in,buffer + iReadLen,8);
		TEAEncrypt((unsigned long*)in,(unsigned long*)out,key);
		memcpy(buffer + iReadLen,out,8);
		iReadLen+=8;
	}
}

